igeo

## Class IStraightener

- java.lang.Object
- - igeo.IDynamicsBase
  - - igeo.IStraightener

- All Implemented Interfaces:
    IDynamics, IStraightenerI, ISubobject, ITensionI

      public class IStraightener
      extends IDynamicsBase
      implements IStraightenerI

  Class of IDynamicsBase to simulate tension force to make 3 points in straight
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `boolean` | `constantTension`
    `double` | `maxTension`
    `IParticleI` | `pt1`
    `IParticleI` | `pt2`
    `IParticleI` | `pt3`
    `double` | `tension` tension is a coefficient to convert distance of two points to amount of force.

    - ### Fields inherited from class igeo.IDynamicsBase

      `parent, targets`

    - ### Fields inherited from interface igeo.ITensionI

      `defaultTension`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IStraightener(IParticleGeo p1, IParticleGeo p2, IParticleGeo p3)`
    `IStraightener(IParticleGeo p1, IParticleGeo p2, IParticleGeo p3, IObject parent)`
    `IStraightener(IParticleI p1, IParticleI p2, IParticleI p3)`
    `IStraightener(IParticleI p1, IParticleI p2, IParticleI p3, IObject parent)`
    `IStraightener(IVecI p1, IVecI p2, IVecI p3)`
    `IStraightener(IVecI p1, IVecI p2, IVecI p3, IObject parent)`
    `IStraightener(IVec p1, IVec p2, IVec p3)`
    `IStraightener(IVec p1, IVec p2, IVec p3, IObject parent)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `constant()` if constantTension is true, amount of force is always constant and it's equals to tension.
    `IStraightener` | `constant(boolean cnst)` if constantTension is true, amount of force is always constant and it's equals to tension.
    `void` | `interact(java.util.ArrayList<IDynamics> dynamics)` behavior definition of interaction with other dynamic objects.
    `double` | `maxTension()` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension.
    `IStraightener` | `maxTension(double maxTension)` if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
    `IStraightener` | `parent(IObject par)` setting parent object
    `IParticleI` | `particle(int i)` alias of pt(int)
    `IParticleI` | `particle1()` alias of pt1()
    `IParticleI` | `particle2()` alias of pt2()
    `IParticleI` | `particle3()` alias of pt3()
    `IVec` | `pos(int i)` position of particle(int i)
    `IVec` | `pos1()` position of particle1
    `IVec` | `pos2()` position of particle2
    `IVec` | `pos3()` position of particle3()
    `IParticleI` | `pt(int i)` getting end point.
    `IParticleI` | `pt1()` getting end point1.
    `IParticleI` | `pt2()` getting end point2.
    `IParticleI` | `pt3()` getting end point3.
    `IStraightener` | `removeTarget(int i)` remove target object.
    `IStraightener` | `removeTarget(IObject obj)` remove target object.
    `IStraightener` | `target(IObject targetObj)` add terget object to be updated by this dynamic object.
    `double` | `tension()` tension is a coefficient to convert distance of two points to amount of force.
    `IStraightener` | `tension(double tension)` tension is a coefficient to convert distance of two points to amount of force.

    - ### Methods inherited from class igeo.IDynamicsBase

      `initDynamicsBase, initDynamicsBase, initDynamicsBase, localDynamics, parent, postinteract, postupdate, preinteract, preupdate, target, targetNum, targets, update, updateTarget`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### pt1

          public IParticleI pt1

    - #### pt2

          public IParticleI pt2

    - #### pt3

          public IParticleI pt3

    - #### tension

          public double tension

      tension is a coefficient to convert distance of two points to amount of force.

    - #### constantTension

          public boolean constantTension

    - #### maxTension

          public double maxTension

  - ### Constructor Detail

    - #### IStraightener

          public IStraightener(IParticleI p1,
                               IParticleI p2,
                               IParticleI p3,
                               IObject parent)

    - #### IStraightener

          public IStraightener(IParticleGeo p1,
                               IParticleGeo p2,
                               IParticleGeo p3,
                               IObject parent)

    - #### IStraightener

          public IStraightener(IVec p1,
                               IVec p2,
                               IVec p3,
                               IObject parent)

    - #### IStraightener

          public IStraightener(IVecI p1,
                               IVecI p2,
                               IVecI p3,
                               IObject parent)

    - #### IStraightener

          public IStraightener(IParticleI p1,
                               IParticleI p2,
                               IParticleI p3)

    - #### IStraightener

          public IStraightener(IParticleGeo p1,
                               IParticleGeo p2,
                               IParticleGeo p3)

    - #### IStraightener

          public IStraightener(IVec p1,
                               IVec p2,
                               IVec p3)

    - #### IStraightener

          public IStraightener(IVecI p1,
                               IVecI p2,
                               IVecI p3)

  - ### Method Detail

    - #### tension

          public double tension()

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### tension

          public IStraightener tension(double tension)

      Description copied from interface: `ITensionI`
      tension is a coefficient to convert distance of two points to amount of force.
      Specified by:
        `tension` in interface `ITensionI`

    - #### constant

          public boolean constant()

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### constant

          public IStraightener constant(boolean cnst)

      Description copied from interface: `ITensionI`
      if constantTension is true, amount of force is always constant and it's equals to tension. Only direction of force changes. But if the distance is zero, force is also zero.
      Specified by:
        `constant` in interface `ITensionI`

    - #### maxTension

          public double maxTension()

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension. if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### maxTension

          public IStraightener maxTension(double maxTension)

      if maxTension is set to be positive number, it limits the force (distance * tension) is cut off at maxTension if constant is set, maxTension is ignored.
      Specified by:
        `maxTension` in interface `ITensionI`

    - #### pt

          public IParticleI pt(int i)

      getting end point. i==0 , i==1 or i==2
      Specified by:
        `pt` in interface `ITensionI`

    - #### particle

          public IParticleI particle(int i)

      alias of pt(int)
      Specified by:
        `particle` in interface `ITensionI`

    - #### pos

          public IVec pos(int i)

      position of particle(int i)
      Specified by:
        `pos` in interface `ITensionI`

    - #### pt1

          public IParticleI pt1()

      getting end point1.
      Specified by:
        `pt1` in interface `ITensionI`

    - #### particle1

          public IParticleI particle1()

      alias of pt1()
      Specified by:
        `particle1` in interface `ITensionI`

    - #### pos1

          public IVec pos1()

      position of particle1
      Specified by:
        `pos1` in interface `ITensionI`

    - #### pt2

          public IParticleI pt2()

      getting end point2.
      Specified by:
        `pt2` in interface `ITensionI`

    - #### particle2

          public IParticleI particle2()

      alias of pt2()
      Specified by:
        `particle2` in interface `ITensionI`

    - #### pos2

          public IVec pos2()

      position of particle2
      Specified by:
        `pos2` in interface `ITensionI`

    - #### pt3

          public IParticleI pt3()

      getting end point3.
      Specified by:
        `pt3` in interface `IStraightenerI`

    - #### particle3

          public IParticleI particle3()

      alias of pt3()
      Specified by:
        `particle3` in interface `IStraightenerI`

    - #### pos3

          public IVec pos3()

      position of particle3()
      Specified by:
        `pos3` in interface `IStraightenerI`

    - #### parent

          public IStraightener parent(IObject par)

      Description copied from interface: `ISubobject`
      setting parent object
      Specified by:
        `parent` in interface `ISubobject`
      Overrides:
        `parent` in class `IDynamicsBase`

    - #### target

          public IStraightener target(IObject targetObj)

      Description copied from class: `IDynamicsBase`
      add terget object to be updated by this dynamic object.
      Specified by:
        `target` in interface `IDynamics`
      Overrides:
        `target` in class `IDynamicsBase`

    - #### removeTarget

          public IStraightener removeTarget(int i)

      Description copied from class: `IDynamicsBase`
      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Overrides:
        `removeTarget` in class `IDynamicsBase`

    - #### removeTarget

          public IStraightener removeTarget(IObject obj)

      Description copied from class: `IDynamicsBase`
      remove target object.
      Specified by:
        `removeTarget` in interface `IDynamics`
      Overrides:
        `removeTarget` in class `IDynamicsBase`

    - #### interact

          public void interact(java.util.ArrayList<IDynamics> dynamics)

      Description copied from class: `IDynamicsBase`
      behavior definition of interaction with other dynamic objects. The server puts all dynamic objects including itself.
      Specified by:
        `interact` in interface `IDynamics`
      Overrides:
        `interact` in class `IDynamicsBase`